org.apache.http.impl.conn

## Class BasicHttpClientConnectionManager

- java.lang.Object
- - org.apache.http.impl.conn.BasicHttpClientConnectionManager

- All Implemented Interfaces:
    Closeable, AutoCloseable, HttpClientConnectionManager

      @Contract(threading=SAFE_CONDITIONAL)
      public class BasicHttpClientConnectionManager
      extends Object
      implements HttpClientConnectionManager, Closeable

  A connection manager for a single connection. This connection manager maintains only one active connection. Even though this class is fully thread-safe it ought to be used by one execution thread only, as only one thread a time can lease the connection at a time.

  This connection manager will make an effort to reuse the connection for subsequent requests with the same `route`. It will, however, close the existing connection and open it for the given route, if the route of the persistent connection does not match that of the connection request. If the connection has been already been allocated `IllegalStateException` is thrown.

  This connection manager implementation should be used inside an EJB container instead of `PoolingHttpClientConnectionManager`.

  Since:
    4.3

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BasicHttpClientConnectionManager()`
    `BasicHttpClientConnectionManager(HttpClientConnectionOperator httpClientConnectionOperator, HttpConnectionFactory<HttpRoute,ManagedHttpClientConnection> connFactory)`
    `BasicHttpClientConnectionManager(org.apache.http.config.Lookup<ConnectionSocketFactory> socketFactoryRegistry)`
    `BasicHttpClientConnectionManager(org.apache.http.config.Lookup<ConnectionSocketFactory> socketFactoryRegistry, HttpConnectionFactory<HttpRoute,ManagedHttpClientConnection> connFactory)`
    `BasicHttpClientConnectionManager(org.apache.http.config.Lookup<ConnectionSocketFactory> socketFactoryRegistry, HttpConnectionFactory<HttpRoute,ManagedHttpClientConnection> connFactory, SchemePortResolver schemePortResolver, DnsResolver dnsResolver)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()`
    `void` | `closeExpiredConnections()` Closes all expired connections in the pool.
    `void` | `closeIdleConnections(long idletime, TimeUnit timeUnit)` Closes idle connections in the pool.
    `void` | `connect(org.apache.http.HttpClientConnection conn, HttpRoute route, int connectTimeout, org.apache.http.protocol.HttpContext context)` Connects the underlying connection socket to the connection target in case of a direct route or to the first proxy hop in case of a route via a proxy (or multiple proxies).
    `protected void` | `finalize()`
    `org.apache.http.config.ConnectionConfig` | `getConnectionConfig()`
    `org.apache.http.config.SocketConfig` | `getSocketConfig()`
    `void` | `releaseConnection(org.apache.http.HttpClientConnection conn, Object state, long keepalive, TimeUnit timeUnit)` Releases the connection back to the manager making it potentially re-usable by other consumers.
    `ConnectionRequest` | `requestConnection(HttpRoute route, Object state)` Returns a new `ConnectionRequest`, from which a `HttpClientConnection` can be obtained or the request can be aborted.
    `void` | `routeComplete(org.apache.http.HttpClientConnection conn, HttpRoute route, org.apache.http.protocol.HttpContext context)` Marks the connection as fully established with all its intermediate hops completed.
    `void` | `setConnectionConfig(org.apache.http.config.ConnectionConfig connConfig)`
    `void` | `setSocketConfig(org.apache.http.config.SocketConfig socketConfig)`
    `void` | `shutdown()` Shuts down this connection manager and releases allocated resources.
    `void` | `upgrade(org.apache.http.HttpClientConnection conn, HttpRoute route, org.apache.http.protocol.HttpContext context)` Upgrades the underlying connection socket to TLS/SSL (or another layering protocol) after having executed `CONNECT` method to all intermediate proxy hops

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BasicHttpClientConnectionManager

          public BasicHttpClientConnectionManager(org.apache.http.config.Lookup<ConnectionSocketFactory> socketFactoryRegistry,
                                          HttpConnectionFactory<HttpRoute,ManagedHttpClientConnection> connFactory,
                                          SchemePortResolver schemePortResolver,
                                          DnsResolver dnsResolver)

    - #### BasicHttpClientConnectionManager

          public BasicHttpClientConnectionManager(HttpClientConnectionOperator httpClientConnectionOperator,
                                          HttpConnectionFactory<HttpRoute,ManagedHttpClientConnection> connFactory)

      Since:
        4.4

    - #### BasicHttpClientConnectionManager

          public BasicHttpClientConnectionManager(org.apache.http.config.Lookup<ConnectionSocketFactory> socketFactoryRegistry,
                                          HttpConnectionFactory<HttpRoute,ManagedHttpClientConnection> connFactory)

    - #### BasicHttpClientConnectionManager

          public BasicHttpClientConnectionManager(org.apache.http.config.Lookup<ConnectionSocketFactory> socketFactoryRegistry)

    - #### BasicHttpClientConnectionManager

          public BasicHttpClientConnectionManager()

  - ### Method Detail

    - #### finalize

          protected void finalize()
                           throws Throwable

      Overrides:
        `finalize` in class `Object`
      Throws:
        `Throwable`

    - #### close

          public void close()

      Specified by:
        `close` in interface `Closeable`
      Specified by:
        `close` in interface `AutoCloseable`

    - #### getSocketConfig

          public org.apache.http.config.SocketConfig getSocketConfig()

    - #### setSocketConfig

          public void setSocketConfig(org.apache.http.config.SocketConfig socketConfig)

    - #### getConnectionConfig

          public org.apache.http.config.ConnectionConfig getConnectionConfig()

    - #### setConnectionConfig

          public void setConnectionConfig(org.apache.http.config.ConnectionConfig connConfig)

    - #### requestConnection

          public final ConnectionRequest requestConnection(HttpRoute route,
                                            Object state)

      Description copied from interface: `HttpClientConnectionManager`
      Returns a new `ConnectionRequest`, from which a `HttpClientConnection` can be obtained or the request can be aborted.

      Please note that newly allocated connections can be returned in the closed state. The consumer of that connection is responsible for fully establishing the route the to the connection target by calling `connect` in order to connect directly to the target or to the first proxy hop, optionally calling `upgrade` method to upgrade the connection after having executed `CONNECT` method to all intermediate proxy hops and and finally calling `routeComplete` to mark the route as fully completed.

      Specified by:
        `requestConnection` in interface `HttpClientConnectionManager`
      Parameters:
        `route` - HTTP route of the requested connection.
        `state` - expected state of the connection or `null` if the connection is not expected to carry any state.

    - #### releaseConnection

          public void releaseConnection(org.apache.http.HttpClientConnection conn,
                               Object state,
                               long keepalive,
                               TimeUnit timeUnit)

      Description copied from interface: `HttpClientConnectionManager`
      Releases the connection back to the manager making it potentially re-usable by other consumers. Optionally, the maximum period of how long the manager should keep the connection alive can be defined using `validDuration` and `timeUnit` parameters.
      Specified by:
        `releaseConnection` in interface `HttpClientConnectionManager`
      Parameters:
        `conn` - the managed connection to release.
        `keepalive` - the duration of time this connection is valid for reuse.
        `timeUnit` - the time unit.
      See Also:
        `HttpClientConnectionManager.closeExpiredConnections()`

    - #### connect

          public void connect(org.apache.http.HttpClientConnection conn,
                     HttpRoute route,
                     int connectTimeout,
                     org.apache.http.protocol.HttpContext context)
                       throws IOException

      Description copied from interface: `HttpClientConnectionManager`
      Connects the underlying connection socket to the connection target in case of a direct route or to the first proxy hop in case of a route via a proxy (or multiple proxies).
      Specified by:
        `connect` in interface `HttpClientConnectionManager`
      Parameters:
        `conn` - the managed connection.
        `route` - the route of the connection.
        `connectTimeout` - connect timeout in milliseconds.
        `context` - the actual HTTP context.
      Throws:
        `IOException`

    - #### upgrade

          public void upgrade(org.apache.http.HttpClientConnection conn,
                     HttpRoute route,
                     org.apache.http.protocol.HttpContext context)
                       throws IOException

      Description copied from interface: `HttpClientConnectionManager`
      Upgrades the underlying connection socket to TLS/SSL (or another layering protocol) after having executed `CONNECT` method to all intermediate proxy hops
      Specified by:
        `upgrade` in interface `HttpClientConnectionManager`
      Parameters:
        `conn` - the managed connection.
        `route` - the route of the connection.
        `context` - the actual HTTP context.
      Throws:
        `IOException`

    - #### routeComplete

          public void routeComplete(org.apache.http.HttpClientConnection conn,
                           HttpRoute route,
                           org.apache.http.protocol.HttpContext context)
                             throws IOException

      Description copied from interface: `HttpClientConnectionManager`
      Marks the connection as fully established with all its intermediate hops completed.
      Specified by:
        `routeComplete` in interface `HttpClientConnectionManager`
      Parameters:
        `conn` - the managed connection.
        `route` - the route of the connection.
        `context` - the actual HTTP context.
      Throws:
        `IOException`

    - #### closeExpiredConnections

          public void closeExpiredConnections()

      Description copied from interface: `HttpClientConnectionManager`
      Closes all expired connections in the pool.

      Open connections in the pool that have not been used for the timespan defined when the connection was released will be closed. Currently allocated connections are not subject to this method. Times will be checked with milliseconds precision.

      Specified by:
        `closeExpiredConnections` in interface `HttpClientConnectionManager`

    - #### closeIdleConnections

          public void closeIdleConnections(long idletime,
                                  TimeUnit timeUnit)

      Description copied from interface: `HttpClientConnectionManager`
      Closes idle connections in the pool.

      Open connections in the pool that have not been used for the timespan given by the argument will be closed. Currently allocated connections are not subject to this method. Times will be checked with milliseconds precision

      All expired connections will also be closed.

      Specified by:
        `closeIdleConnections` in interface `HttpClientConnectionManager`
      Parameters:
        `idletime` - the idle time of connections to be closed
        `timeUnit` - the unit for the `idletime`
      See Also:
        `HttpClientConnectionManager.closeExpiredConnections()`

    - #### shutdown

          public void shutdown()

      Description copied from interface: `HttpClientConnectionManager`
      Shuts down this connection manager and releases allocated resources. This includes closing all connections, whether they are currently used or not.
      Specified by:
        `shutdown` in interface `HttpClientConnectionManager`

Copyright © 1999–2022 The Apache Software Foundation. All rights reserved.